<?php
require_once(dirname(__FILE__).'../../mpaycallerservice.php');
include_once '/classes/order/Order.php';
class MyanpayPaymentModuleFrontController extends ModuleFrontController
{	
	public $ssl = true;
	public $display_column_left = false;
	
	public function initContent()
	{	
		if (!$this->context->customer->isLogged() || empty($this->context->cart))
			Tools::redirect('index.php');

		parent::initContent();
		$this->myanpay = new Myanpay();
		$this->context = Context::getContext();
		$this->id_module = (int)Tools::getValue('id_module');
		$cart = $this->context->cart;
		$currency = new Currency((int)$this->context->cart->id_currency);
		$currencies_module = Currency::getCurrency((int)$this->context->cart->id_currency);

		/*===============  Start Currency Check   ===============*/
		$search = array("Myanmar Kyat", "Myanmar", "Burmese", "Burma", "kyats", "kyat" , "MMK", "Ks", "K", "104" );
		$search = array_map('strtolower', $search);
		
		$mp_contain = array_map('strtolower', $currencies_module);
		$mp_check = false;
		foreach ($search as $s) 
		{
		if (in_array($s, $mp_contain))
		{
		$mp_check = true;
		}
		}
		
		if(!($mp_check))
		{
			$msgTitle = ' The MyanPay Payment Server has returned a currency error! ';
			$mpayerrmsg1 = ' Invalid currency code.';	
			$mpayerrmsg2 = ' MyanPay Payment System accept only Myanmar Kyat.';
			$mpayerrmsg3 = ' Please change your currency to Myanmar Kyat (MMK or KS) and retry the request.';	
			$mpayerrmsg = array($mpayerrmsg1,$mpayerrmsg2,$mpayerrmsg3);
			
			setcookie('refreshed', 'end');
						
			$this->context->smarty->assign(array(
				'logs' => $mpayerrmsg,
				'message' => $msgTitle
			));
			$this->setTemplate('order-message.tpl');
		} /*===============  End Currency Check   ===============*/
		else 
		{
			if($_COOKIE['refreshed'] == 'start')
			{
				/*++++++++++++++++++[ Start MyanPay API ]++++++++++++++++++++*/
		
				$pageURL = 'http';
				if (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on")
				{
					$pageURL .= "s";
				}
				$pageURL .= "://";
				
				if ($_SERVER["SERVER_PORT"] != "80")
				{
					$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"];
				} else {
					$pageURL .= $_SERVER["SERVER_NAME"];
				}
				
				$requestURI = explode("myanpay", $_SERVER['REQUEST_URI']);
				$url=dirname($pageURL . $requestURI[0] );
				
				$returnURL = urlencode($url . "/" . "index.php?fc=module&module=myanpay&controller=confirm&");
				$cancelURL = urlencode($url . "/" . "index.php?route=checkout/checkout");
				
				$nvpstr1 = "&apiusername=" . Configuration::get('MYANPAY_API_USERNAME') .
					"&apipassword=" . Configuration::get('MYANPAY_API_PASSWORD') . 
					"&apisignature=" . Configuration::get('MYANPAY_API_SIGNATURE') . 
					"&version=1.1" .
					"&paymentaction=Sale" .
					"&returnUrl=" . $returnURL .
					"&cancelUrl=" . $cancelURL ;
					
				$w = 0;
				$productAmt = 0;
				$nvpstr2 = "";
				foreach ($cart->getProducts() as $order_product)
				{
					$nvpstr2 = $nvpstr2 . "&paymentRequest_ItemNumber$w=I-10$w" .
					"&paymentRequest_ItemName$w=" . $order_product['name'] .
					"&paymentRequest_ItemAmt$w=" . number_format($order_product['price_wt'], 2, '.', '') .
					"&paymentRequest_ItemQty$w=" . (int)$order_product['cart_quantity'] ;
					$w++;
					$productAmt= $productAmt + number_format($order_product['price_wt']*(int)$order_product['cart_quantity'], 2, '.', '');
				}
				
				$nvpstr3 ="" ;
				$ship= $cart->simulateCarriersOutput();
				$shipSelect= $cart->simulateCarrierSelectedOutput();
				foreach ($ship as $carrier)
				{
					if($shipSelect== $carrier['id_carrier'])
					{
						$delivery =$carrier['name'];
					}
				}
				
				$shippingAmt = 0;
				if($cart->getTotalShippingCost())
				{
					$nvpstr3 = $nvpstr3 . "&paymentRequest_ItemNumber$w=SM-001"  .
					"&paymentRequest_ItemName$w=" . $delivery .  
					"&paymentRequest_ItemAmt$w=" . number_format($cart->getTotalShippingCost(), 2, '.', '') .
					"&paymentRequest_ItemQty$w=1" ;
					$w++;
					$shippingAmt = number_format($cart->getTotalShippingCost(), 2, '.', '');
				}
				
				//var_dump($this->context->cart->getCartRules());
				//exit;
				
				$nvpstr4 = $nvpstr5 = $giftAmt = $couponAmt = "";
				$available = $code = $gift = 0;

				$available_cart_rules = CartRule::getCustomerCartRules($this->context->language->id, (isset($this->context->customer->id) ? $this->context->customer->id : 0), true, true, true, $this->context->cart, false, true);
				$cart_cart_rules = $this->context->cart->getCartRules();
		
				foreach ($available_cart_rules as $key => $available_cart_rule) {
					foreach ($cart_cart_rules as $cart_cart_rule) {
						if ($available_cart_rule['id_cart_rule'] == $cart_cart_rule['id_cart_rule']) {
						$name = $cart_cart_rule['name'];
						$available = $available_cart_rule['id_cart_rule'];
						
							if(strpos($name,'gift') !== false)
							{
							$gift = (int)$cart_cart_rule['value_real'];
							$nvpstr4 = $nvpstr4 . "&paymentRequest_ItemNumber$w=G-001"  .
							"&paymentRequest_ItemName$w=GiftVoucher" . 
							"&paymentRequest_ItemAmt$w=-" .$gift .
							"&paymentRequest_ItemQty$w=1" ;
							$w++;
							$giftAmt .= $gift;	
							}
							
							if(strpos($name,'Coupon') !== false)
							{
							$coupon = (int)$cart_cart_rule['value_real'];
							$nvpstr5 = $nvpstr5 . "&paymentRequest_ItemNumber$w=C-001"  .
							"&paymentRequest_ItemName$w=Coupon" . 
							"&paymentRequest_ItemAmt$w=-" .$coupon .
							"&paymentRequest_ItemQty$w=1" ;
							$w++;
							$couponAmt .= $coupon;
							
							}
						}
					}
				}
				$nvpstr6 = "";	
				$wrapAmt = 0;
				if($cart->gift)
				{
					$giftWrappingPrice = Tools::convertPrice($cart->getGiftWrappingPrice(), Currency::getCurrencyInstance((int)$currency->id));
					$nvpstr6 = $nvpstr6 . "&paymentRequest_ItemNumber$w=GW-001"  .
					"&paymentRequest_ItemName$w=Gift-Wrapping" . 
					"&paymentRequest_ItemAmt$w=" . number_format($giftWrappingPrice, 2, '.', '') .
					"&paymentRequest_ItemQty$w=1" ;
					$w++;
					$wrapAmt = number_format($giftWrappingPrice, 2, '.', '');
				}
				//echo $giftWrappingPrice."<br>";
				//echo $wrapAmt;
			   // exit;
		
				$mpayTotalAmt = $productAmt + $shippingAmt - $giftAmt - $couponAmt + $wrapAmt;
				//echo $mpayTotalAmt . '__ ' . $productAmt . '__ ' . $shippingAmt . '__ ' . $giftAmt.'___'.$couponAmt.'____'.$wrapAmt;
				//exit;
				$mpayTotalAmt = number_format($mpayTotalAmt, 2, '.', '');
		
				$cookie = Context::getContext()->cookie;
				$cookie->setAmt = $mpayTotalAmt;
				//echo $cookie->setAmt;
				//exit;
				$nvpstr7 ="&NoShipping=true" .
				"&paymentRequest_ItemTotalAmt=" . $mpayTotalAmt .
				"&paymentRequest_Amt=" . $mpayTotalAmt ;
				
				$nvpstr8 ="&EcHeaderImage=" . Configuration::get('MYANPAY_LOGO') .
					"&EcBrandName=" . Configuration::get('MYANPAY_BRAND_NAME') .
					"&EcCustomerServiceNumber=" . Configuration::get('MYANPAY_SELLER_PHONE') ;
				
				$nvpstr =  $nvpstr1 . $nvpstr2 .  $nvpstr3 . $nvpstr4 . $nvpstr5 . $nvpstr6 .$nvpstr7 .$nvpstr8 ;
				//echo $nvpstr;
				//exit;
				//$customer = new Customer($cart->id_customer);
				
				//if (!Validate::isLoadedObject($customer))
				//Tools::redirect('index.php?controller=order&step=1');
				
				$resArray=hash_call("SetExpressCheckout",$nvpstr,Configuration::get('MYANPAY_MODE'));	
				//var_dump($resArray);
				//exit;
				if (isset($resArray["mpayerr"]) && ($resArray["mpayerr"] == "ErrorOccur"))
				{
					$msgTitle = ' The MyanPay Payment Server has returned an error! ';
					$mpayerrmsg1 = ' Error No &nbsp; :: &nbsp; &nbsp;' . $resArray["mpayerrNo"];	
					$mpayerrmsg2 = ' Message &nbsp; :: &nbsp; &nbsp;' . $resArray["mpayerrMsg"];
					$mpayerrmsg = array($mpayerrmsg1,$mpayerrmsg2);													
					$this->context->smarty->assign(array(
						'logs' => $mpayerrmsg,
						'message' => $msgTitle
					));
					$this->setTemplate('order-message.tpl');
					
				} else  {
					$ack = strtoupper($resArray["Ack"]);
					if($ack=="SUCCESS")
					{	
						/*$strTime = '[ ' . date("h:i:s A") . ' ] - ';
						$message = $strTime .'Start MyanPay SetExpressCheckOut';
						
						$this->module->validateOrder((int)$cart->id,1,0,'SetExpressCheckOut', $message, array(), (int)$currency->id, false, $customer->secure_key);
						Tools::redirect('index.php?fc=module&module=myanpay&controller=confirm ='.$cart->id.'&id_module='.$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);
					*/
						$token = urldecode($resArray["Token"]);
    
						if(Configuration::get('MYANPAY_MODE') == "1")
						{
							$myanpayURL = "https://www.myanpay.com.mm/Personal/ExpressCheckout/ExpressCheckoutLogin.aspx?cmd=express-checkout&token=" .$token;
						} else  {   
							$myanpayURL = "https://www.myanpay-virtualbox.com/Personal/ExpressCheckout/ExpressCheckoutLogin.aspx?cmd=express-checkout&token=" .$token;
						}
						header("Location: " . $myanpayURL);
						
					} else if($ack=="FAIL") {
						
						$msgTitle = ' The MyanPay Payment Server has returned an error! ';
						foreach($resArray as $key => $value)
						{
							$nvpErr[] = $key . ' :: ' . $value;
						}
						$this->context->smarty->assign(array(
							'logs' => $nvpErr,
							'message' => $msgTitle
						));
						$this->setTemplate('order-message.tpl');
						
					} else  {
						
						$msgTitle = ' Unable to Establish MyanPay Payment Server! ';
						$mpayerrmsg1 = ' Your request cannot be completed because the service could not be found or did not respond. ';	
						$mpayerrmsg2 = ' Please try again for your payment process.';
						$mpayerrmsg = array($mpayerrmsg1,$mpayerrmsg2);
														
						$this->context->smarty->assign(array(
							'logs' => $mpayerrmsg,
							'message' => $msgTitle
						));
						$this->setTemplate('order-message.tpl');
					}
					
				}
				
			} else {
				header("Location: index.php?controller=order");
			}
		}
	}
	
}
