<?php
require_once(dirname(__FILE__).'../../mpaycallerservice.php');
class MyanpayValidationModuleFrontController extends ModuleFrontController
{

	public function postProcess()
	
	{		
		$cart = $this->context->cart;

		if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)
			Tools::redirect('index.php?controller=order&step=1');
		// Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
			$cookie = Context::getContext()->cookie;
			$setAmt = $cookie->setAmt;
			$getAmt = $cookie->getAmt;
			//echo $setAmt.'-------'.$getAmt;
			//exit;
			$Check_Amt = true;
			$Check_Cookie = true;
			if (empty($setAmt) != empty($getAmt)) 
			{	
				$Check_Cookie = false;
				$msgTitle = 'Session Expire';
				$mpayerrmsg1 = "Now your order session is expired. \n Please checkout your order again.";
				$mpayerrmsg = array($mpayerrmsg1);
												
				$this->context->smarty->assign(array(
					'logs' => $mpayerrmsg,
					'message' => $msgTitle
				));
				$this->setTemplate('order-message.tpl');
			
			} else {
				$CheckSet_Amt = trim($setAmt);
				$CheckGet_Amt = trim($getAmt);
				if($CheckSet_Amt != $CheckGet_Amt)
				{
					$Check_Amt = false;
					$msgTitle = 'Order Total amount does not match';
					$mpayerrmsg1 = "Now your order total amount dose not match. \n Your actual total balance may be different. \n Please check your order total amount.";
					$mpayerrmsg = array($mpayerrmsg1);
					
					$this->context->smarty->assign(array(
					'logs' => $mpayerrmsg,
					'message' => $msgTitle
					));
					$this->setTemplate('order-message.tpl');
				}
			}
		if($Check_Cookie && $Check_Amt)
		{
		$authorized = false;
		foreach (Module::getPaymentModules() as $module)
			if ($module['name'] == 'myanpay')
			{
				$authorized = true;
				break;
			}

		if (!$authorized)
			die($this->module->l('This payment method is not available.', 'validation'));
			
		$customer = new Customer($cart->id_customer);

		if (!Validate::isLoadedObject($customer))
			Tools::redirect('index.php?controller=order&step=1');
			
		$nvpstr = "&apiusername=" . Configuration::get('MYANPAY_API_USERNAME') .
		"&apipassword=" . Configuration::get('MYANPAY_API_PASSWORD') . 
		"&apisignature=" . Configuration::get('MYANPAY_API_SIGNATURE') . 
		"&version=1.1" .
		"&paymentaction=Sale" .
		"&payerID=" . urlencode($_REQUEST['payerId']) .
		"&token=" . urlencode($_REQUEST['token']).
		"&paymentRequest_Amt=" . $setAmt;
		//echo $nvpstr;
		//exit;
		/*take mpaytotalAmt with cookie*/

		//====================================
		
		$resArray=hash_call("DoExpressCheckout",$nvpstr,Configuration::get('MYANPAY_MODE'));		
		//var_dump($resArray);
		//exit;		
		if (isset($resArray["mpayerr"]) && ($resArray["mpayerr"] == "ErrorOccur"))
		{	
			$msgTitle = ' The MyanPay Payment Server has returned an error! ';
			$mpayerrmsg1 = ' Error No &nbsp; :: &nbsp; &nbsp;' . $resArray["mpayerrNo"];	
			$mpayerrmsg2 = ' Message &nbsp; :: &nbsp; &nbsp;' . $resArray["mpayerrMsg"];
			$mpayerrmsg = array($mpayerrmsg1,$mpayerrmsg2);													
			$this->context->smarty->assign(array(
				'logs' => $mpayerrmsg,
				'message' => $msgTitle
			));
			$this->setTemplate('order-message.tpl');
			
		} else  {
			$ack = strtoupper($resArray["Ack"]);		
			if($ack=="SUCCESS")
			{	
				$currency = $this->context->currency;
				$total = (float)$cart->getOrderTotal(true, Cart::BOTH);
				$strTime = '[ ' . date("h:i:s A") . ' ] - ';
				$message = $strTime .'Payment received '.$setAmt.'Ks with MyanPay Transaction ID - '. $resArray["PaymentInfo_TransactionID"];
				
				$extra_vars =	array(				
					'transaction_id' => $resArray["PaymentInfo_TransactionID"]
				);
				$this->module->validateOrder((int)$cart->id, Configuration::get('MYANPAY_ORDER_STATUS'), $total, $this->module->displayName, $message, $extra_vars, (int)$currency->id, false, $customer->secure_key);
				
				$this->context->smarty->assign(array(
					'is_guest' => $this->context->customer->is_guest,				
					'Currency' => $currency->sign,
					'logos' => 'modules/myanpay/img/myanpaylogo.png',
					'Total' => $total,
					'OrderNo' => $this->module->currentOrderReference,
					'CartID' => (int)$new_cart->id,
					'TID' => $resArray["PaymentInfo_TransactionID"],
					'Status' => $resArray["PaymentInfo_PaymentStatus"],
					'OrderTime' => $resArray["TimeStamp"] . ' . ' . $resArray["PaymentInfo_OrderTime"],
					'Type' => $resArray["PaymentInfo_TransactionType"],
					'Key' => $customer->secure_key
				));
				
				if ($this->context->customer->is_guest)
				{
					$this->context->smarty->assign(array(
						'id_order' => $this->id_order,
						'reference_order' => $this->reference,
						'id_order_formatted' => sprintf('#%06d', $this->id_order),
						'email' => $this->context->customer->email
					));
					/* If guest we clear the cookie for security reason */
					$this->context->customer->mylogout();
				}
				
				$this->setTemplate('order-confirmation.tpl');
		
			} else if($ack=="FAIL") {
						
				$msgTitle = ' The MyanPay Payment Server has returned an error! ';
				foreach($resArray as $key => $value)
				{
					$nvpErr[] = $key . ' :: ' . $value;
				}
				$this->context->smarty->assign(array(
					'logs' => $nvpErr,
					'message' => $msgTitle
				));
				$this->setTemplate('order-message.tpl');
				
			} else  {
				
				$msgTitle = ' Unable to Establish MyanPay Payment Server! ';
				$mpayerrmsg1 = ' Your request cannot be completed because the service could not be found or did not respond. ';	
				$mpayerrmsg2 = ' Please try again for your payment process.';
				$mpayerrmsg = array($mpayerrmsg1,$mpayerrmsg2);
												
				$this->context->smarty->assign(array(
					'logs' => $mpayerrmsg,
					'message' => $msgTitle
				));
				$this->setTemplate('order-message.tpl');
			
				}
			}
		}
	}
}
