<?php
class myanpay extends PaymentModule
{
	private $_html = '';
	private $_postErrors = array();

    public  $apiusername;
	public  $apipassword;
	public	$apisignature;
	public	$orderstatus;
	public  $mpaymode;
	public  $headerlogo;
	public  $brandname;
	public	$sellerphone;

	public function __construct()
	{
		$this->name = 'myanpay';
		$this->tab = 'payments_gateways';
		$this->version = '1.1';
		$this->author = 'Soft-Gate';

        $this->currencies = true;
		$this->currencies_mode = 'checkbox';

        $config = Configuration::getMultiple(array('MYANPAY_API_USERNAME', 'MYANPAY_API_PASSWORD', 'MYANPAY_API_SIGNATURE', 'MYANPAY_ORDER_STATUS', 'MYANPAY_MODE', 'MYANPAY_LOGO', 'MYANPAY_BRAND_NAME', 'MYANPAY_SELLER_PHONE'));
		if (isset($config['MYANPAY_API_USERNAME']))
			$this->apiusername = $config['MYANPAY_API_USERNAME'];
		if (isset($config['MYANPAY_API_PASSWORD']))
			$this->apipassword = $config['MYANPAY_API_PASSWORD'];
		if (isset($config['MYANPAY_API_SIGNATURE']))
			$this->apisignature = $config['MYANPAY_API_SIGNATURE'];	
		if (isset($config['MYANPAY_ORDER_STATUS']))
			$this->orderstatus = $config['MYANPAY_ORDER_STATUS'];	
		if (isset($config['MYANPAY_MODE']))
			$this->mpaymode = $config['MYANPAY_MODE'];
		if (isset($config['MYANPAY_LOGO']))
			$this->headerlogo = $config['MYANPAY_LOGO'];
		if (isset($config['MYANPAY_BRAND_NAME']))
			$this->brandname = $config['MYANPAY_BRAND_NAME'];
		if (isset($config['MYANPAY_SELLER_PHONE']))
			$this->sellerphone = $config['MYANPAY_SELLER_PHONE'];
		
		parent::__construct();
		/* The parent construct is required for translations */

		$this->displayName = $this->l('MyanPay');		
		$this->description = $this->l('MyanPay payment gateway. Accept Myanmar Kyat.');
		
		$this->confirmUninstall = $this->l('Are you sure you want to delete your MyanPay merchant account details?');
		
		if (!isset($this->apiusername) OR !isset($this->apipassword) OR !isset($this->apisignature) OR !isset($this->orderstatus))
			$this->warning = $this->l('MyanPay API Username, API Password, API Signature and Order Status must be configured in order to use this module correctly.');
		
		if (!sizeof(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('No currency set for this module');
	}
	public function install()
	{
		if (!parent::install() OR !$this->registerHook('payment') OR !$this->registerHook('paymentReturn'))
			return false;
		return true;
	}

	public function uninstall()
    {
		if (!Configuration::deleteByName('MYANPAY_API_USERNAME')
				OR !Configuration::deleteByName('MYANPAY_API_PASSWORD')
				OR !Configuration::deleteByName('MYANPAY_API_SIGNATURE')
				OR !Configuration::deleteByName('MYANPAY_ORDER_STATUS')
				OR !Configuration::deleteByName('MYANPAY_MODE')
				OR !Configuration::deleteByName('MYANPAY_LOGO')
				OR !Configuration::deleteByName('MYANPAY_BRAND_NAME')
				OR !Configuration::deleteByName('MYANPAY_SELLER_PHONE')				
				OR !parent::uninstall())
			return false;
		return true;
	}
	
	private function _postValidation()
    {
        if (isset($_POST['btnSubmit']))
        {
            if (empty($_POST['apiusername']))
                $this->_postErrors[] = $this->l('API username is required.');
            elseif (empty($_POST['apipassword']))
                $this->_postErrors[] = $this->l('API password is required.');
            elseif (empty($_POST['apisignature']))
                $this->_postErrors[] = $this->l('API signature is required.');
			elseif (empty($_POST['orderstatus']))
                $this->_postErrors[] = $this->l('Order status is required.');
        }
    }
    
    private function _postProcess()
    {
        if (isset($_POST['btnSubmit']))
        {
            Configuration::updateValue('MYANPAY_API_USERNAME', $_POST['apiusername']);
            Configuration::updateValue('MYANPAY_API_PASSWORD', $_POST['apipassword']);
            Configuration::updateValue('MYANPAY_API_SIGNATURE', $_POST['apisignature']);
			Configuration::updateValue('MYANPAY_ORDER_STATUS', $_POST['orderstatus']);
			Configuration::updateValue('MYANPAY_MODE', $_POST['mpaymode']);
            Configuration::updateValue('MYANPAY_LOGO', $_POST['headerlogo']);
			Configuration::updateValue('MYANPAY_BRAND_NAME', $_POST['brandname']);
            Configuration::updateValue('MYANPAY_SELLER_PHONE', $_POST['sellerphone']);
        }
        $this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('ok').'" /> '.$this->l('Settings updated').'</div>';
    }
    
    private function _displayMyanpaycheckout()
    {
        $this->_html .= '<div style="float: right; width: 440px; height: 150px; border: dashed 1px #666; padding: 8px; margin-left: 12px;">
            <h2>'.$this->l('Open a MyanPay account').'</h2>
            <div style="clear: both;"></div>
            <p>'.$this->l('Click on the following image to sign-up for a MyanPay account (no upfront fees or monthly fees) -').' <em>'.$this->l('we only make money when you make money.').'</em></p>
            <p style="text-align: center;"><a href="https://www.myanpay.com.mm/Personal/SignUpStartPage.aspx" target=_blank><img src="../modules/myanpay/img/myanpayflow.jpg" alt="PrestaShop & MyanPay" style="margin-top: 12px;" /></a></p>
            <p></p>
            <div style="clear: right;"></div>
        </div>
        <img src="../modules/myanpay/img/myanpaylogo.png" style="float:left; margin-right:15px;"><b>'.$this->l('This module allows you to accept payments via MyanPay Express Checkout.').'</b><br /><em>'.$this->l('(MyanPay provides services to merchants worldwide).').'</em><br /><br />'.$this->l('Achieve PA-DSS compliance for PrestaShop using the MyanPay Express Checkout payment module. MyanPay collects, stores and processes the sensitive payment data for you.').'<br /><br /><strong></em><br /><br />';
    }
    
    private function _displayForm()
    {
        $this->_html .=
        '<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
            <fieldset>
            <legend><img src="../img/admin/contact.gif" />'.$this->l('MyanPay Business Account settings').'</legend>
			<label for="apiusername">'.$this->l('API Username').' <sup>*</sup>'.'</label>
			<div class="margin-form">
				<input type="text" name="apiusername" value="'.htmlentities(Tools::getValue('apiusername', $this->apiusername), ENT_COMPAT, 'UTF-8').'" size="35"/>
				<p>'.$this->l('API Username, i.e.').' <strong>'.$this->l('_HninH3499844562_myanpayAPI').'</strong></p>
			</div>
				
			<label for="apipassword">'.$this->l('API Password').' <sup>*</sup></label>
			<div class="margin-form">
				<input type="text" name="apipassword" value="'.htmlentities(Tools::getValue('apipassword', $this->apipassword), ENT_COMPAT, 'UTF-8').'" size="35" />
				<p>'.$this->l('API Password, i.e.').' <strong>'.$this->l('U7TN977IH831HHKX').'</strong></p>
			</div>
				
			<label for="apisignature">'.$this->l('API Signature'). ' <sup>*</sup></label>
			<div class="margin-form">
				<input type="text" name="apisignature" value="'.htmlentities(Tools::getValue('apisignature', $this->apisignature), ENT_COMPAT, 'UTF-8').'" size="35" />
				<p>'.$this->l('API Signature, i.e.').' <strong>'.$this->l('3mj68....').'</strong></p>
			</div>
			
			<label for="orderstatus">'.$this->l('Order Status'). ' <sup>*</sup></label>
			<div class="margin-form">
				<input type="text" name="orderstatus" value="'.htmlentities(Tools::getValue('orderstatus', $this->orderstatus), ENT_COMPAT, 'UTF-8').'" size="10" />
				<p>'.$this->l('Please add your Order Status ID. View detail ').' <a href="index.php?controller=AdminStatuses&token=' . Tools::getAdminTokenLite('AdminStatuses') .'" target="_blank" > here <img src="../img/admin/details.gif" alt="'.$this->l('See').'" /> </a> 				
				</p>
			</div>
			
			<label for="mpaymode">'.$this->l('Mode'). '</label>
			<div class="margin-form">
			
				<input type="radio" name="mpaymode" value="1" '.(Tools::getValue('mpaymode', $this->mpaymode) == 1 ? 'checked="checked"' : '').' /> Live mode &nbsp; | &nbsp; 
				<input type="radio" name="mpaymode" value="0" '.(Tools::getValue('mpaymode', $this->mpaymode) == 0 ? 'checked="checked"' : '').' /> Test mode
				<p> Live mode == Use the live (https://www.myanpay.com.mm) payment gateway server.</p>
				<p> Test mode == Testing mode (https://www.myanpay-virtualbox.com) </p>	
				
			</div>
			
			<label for="headerlogo">'.$this->l('Header Logo'). '</label>
			<div class="margin-form">
				<input type="text" name="headerlogo" value="'.htmlentities(Tools::getValue('headerlogo', $this->headerlogo), ENT_COMPAT, 'UTF-8').'" size="50" />
				<p>'.$this->l('e.g.').' <strong>'.$this->l('http://www.yourdomain.com/images/logo.png').'</strong></p>
			</div>
			
			<label for="brandname">'.$this->l('Brand Name'). '</label>
			<div class="margin-form">
				<input type="text" name="brandname" value="'.htmlentities(Tools::getValue('brandname', $this->brandname), ENT_COMPAT, 'UTF-8').'" size="35" />
			</div>
			
			<label for="sellerphone">'.$this->l('Seller Phone'). '</label>
			<div class="margin-form">
				<input type="text" name="sellerphone" value="'.htmlentities(Tools::getValue('sellerphone', $this->sellerphone), ENT_COMPAT, 'UTF-8').'" size="35" />
			</div>
				
			<div class="margin-form">
				<input class="button" name="btnSubmit" value="'.$this->l('Update settings').'" type="submit" />
			</div>
            </fieldset>
        </form>';
    }
    
    public function getContent()
    {
        $this->_html = '<h2>'.$this->displayName.'</h2>';

        if (!empty($_POST))
        {
            $this->_postValidation();
            if (!sizeof($this->_postErrors))
                $this->_postProcess();
            else
                foreach ($this->_postErrors AS $err)
                    $this->_html .= '<div class="alert error">'. $err .'</div>';
        }
        else
            $this->_html .= '<br />';

    
        $this->_displayMyanpaycheckout();
        $this->_displayForm();

        return $this->_html;
    }
    public function hookPayment($params)
    {
        if (!$this->active)
            return ;
        if (!$this->_checkCurrency($params['cart']))
            return ;

        global $smarty;

        $smarty->assign(array(
            'this_path' => $this->_path,
            'this_path_ssl' => Tools::getShopDomainSsl(true, true).__PS_BASE_URI__.'modules/'.$this->name.'/'
        ));
		setcookie('refreshed', 'start');
        return $this->display(__FILE__, 'views/myanpay_checkout.tpl');
    }
   
    private function _checkCurrency($cart)
    {
        $currency_order = new Currency((int)($cart->id_currency));
        $currencies_module = $this->getCurrency((int)$cart->id_currency);
        $currency_default = Configuration::get('PS_CURRENCY_DEFAULT');
        
        if (is_array($currencies_module))
            foreach ($currencies_module AS $currency_module)
                if ($currency_order->id == $currency_module['id_currency'])
                    return true;
    }
	
	public function hookPaymentReturn($params)
	{
		if (!$this->active)
			return;
			
		$id_module = (int) Tools::getValue('id_module');
		if ($id_module === (int) $this->id) {
			$orderHistory = new OrderHistory();
			$orderHistory->changeIdOrderState(Configuration::get('MYANPAY_ORDER_STATUS'), $params['objOrder']);
		}
	}
}
